Bullet Collision Detection & Physics Library: btConvex2dShape Class Reference

Bullet Collision Detection & Physics Library

Public Member Functions | Private Attributes | List of all members
btConvex2dShape Class Reference

The btConvex2dShape allows to use arbitrary convex shapes as 2d convex shapes, with the Z component assumed to be 0. More...

`#include <btConvex2dShape.h>`

Inheritance diagram for btConvex2dShape:
[legend]
Collaboration diagram for btConvex2dShape:
[legend]

## Public Member Functions
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConvex2dShape (btConvexShape *convexChildShape)
virtual | ~btConvex2dShape ()
virtual btVector3 | localGetSupportingVertexWithoutMargin (const btVector3 &vec) const
virtual btVector3 | localGetSupportingVertex (const btVector3 &vec) const
virtual void | batchedUnitVectorGetSupportingVertexWithoutMargin (const btVector3 *vectors, btVector3 *supportVerticesOut, int numVectors) const
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const
btConvexShape * | getChildShape ()
const btConvexShape * | getChildShape () const
virtual const char * | getName () const
void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
| getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version
virtual void | getAabbSlow (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | setLocalScaling (const btVector3 &scaling)
virtual const btVector3 & | getLocalScaling () const
virtual void | setMargin (btScalar margin)
virtual btScalar | getMargin () const
virtual int | getNumPreferredPenetrationDirections () const
virtual void | getPreferredPenetrationDirection (int index, btVector3 &penetrationVector) const
Public Member Functions inherited from btConvexShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConvexShape ()
| not supported on IBM SDK, until we fix the alignment of btVector3
virtual | ~btConvexShape ()
btVector3 | localGetSupportVertexWithoutMarginNonVirtual (const btVector3 &vec) const
btVector3 | localGetSupportVertexNonVirtual (const btVector3 &vec) const
btScalar | getMarginNonVirtual () const
void | getAabbNonVirtual (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | project (const btTransform &trans, const btVector3 &dir, btScalar &minProj, btScalar &maxProj, btVector3 &witnesPtMin, btVector3 &witnesPtMax) const
Public Member Functions inherited from btCollisionShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btCollisionShape ()
virtual | ~btCollisionShape ()
virtual void | getBoundingSphere (btVector3 &center, btScalar &radius) const
virtual btScalar | getAngularMotionDisc () const
| getAngularMotionDisc returns the maximum radius needed for Conservative Advancement to handle time-of-impact with rotations.
virtual btScalar | getContactBreakingThreshold (btScalar defaultContactThresholdFactor) const
void | calculateTemporalAabb (const btTransform &curTrans, const btVector3 &linvel, const btVector3 &angvel, btScalar timeStep, btVector3 &temporalAabbMin, btVector3 &temporalAabbMax) const
| calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative
bool | isPolyhedral () const
bool | isConvex2d () const
bool | isConvex () const
bool | isNonMoving () const
bool | isConcave () const
bool | isCompound () const
bool | isSoftBody () const
bool | isInfinite () const
| isInfinite is used to catch simulation error (aabb check)
int | getShapeType () const
virtual btVector3 | getAnisotropicRollingFrictionDirection () const
| the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example
void | setUserPointer (void *userPtr)
| optional user data pointer
void * | getUserPointer () const
void | setUserIndex (int index)
int | getUserIndex () const
void | setUserIndex2 (int index)
int | getUserIndex2 () const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure)
virtual void | serializeSingleShape (btSerializer *serializer) const

## Private Attributes
btConvexShape * | m_childConvexShape

## Additional Inherited Members
Protected Attributes inherited from btCollisionShape
int | m_shapeType
void * | m_userPointer
int | m_userIndex
int | m_userIndex2

## Detailed Description

The btConvex2dShape allows to use arbitrary convex shapes as 2d convex shapes, with the Z component assumed to be 0.

For 2d boxes, the btBox2dShape is recommended.

Definition at line 24 of file btConvex2dShape.h.

## Constructor & Destructor Documentation

## ◆ btConvex2dShape()

btConvex2dShape::btConvex2dShape | ( | btConvexShape * | convexChildShape | ) |

Definition at line 18 of file btConvex2dShape.cpp.

## ◆ ~btConvex2dShape()

btConvex2dShape::~btConvex2dShape | ( |  | ) |
| virtual

Definition at line 23 of file btConvex2dShape.cpp.

## Member Function Documentation

## ◆ batchedUnitVectorGetSupportingVertexWithoutMargin()

void btConvex2dShape::batchedUnitVectorGetSupportingVertexWithoutMargin | ( | const btVector3 * | vectors,
|  | btVector3 * | supportVerticesOut,
|  | int | numVectors ) const
| virtual

Implements btConvexShape.

Definition at line 32 of file btConvex2dShape.cpp.

## ◆ BT_DECLARE_ALIGNED_ALLOCATOR()

btConvex2dShape::BT_DECLARE_ALIGNED_ALLOCATOR | ( |  | ) |

## ◆ calculateLocalInertia()

void btConvex2dShape::calculateLocalInertia | ( | btScalar | mass,
|  | btVector3 & | inertia ) const
| virtual

this linear upscaling is not realistic, but we don't deal with large mass ratios...

Implements btCollisionShape.

Definition at line 42 of file btConvex2dShape.cpp.

## ◆ getAabb()

void btConvex2dShape::getAabb | ( | const btTransform & | t,
|  | btVector3 & | aabbMin,
|  | btVector3 & | aabbMax ) const
| virtual

getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version

Implements btConvexShape.

Definition at line 49 of file btConvex2dShape.cpp.

## ◆ getAabbSlow()

void btConvex2dShape::getAabbSlow | ( | const btTransform & | t,
|  | btVector3 & | aabbMin,
|  | btVector3 & | aabbMax ) const
| virtual

Implements btConvexShape.

Definition at line 54 of file btConvex2dShape.cpp.

## ◆ getChildShape() [1/2]

btConvexShape * btConvex2dShape::getChildShape | ( |  | ) |
| inline

Definition at line 44 of file btConvex2dShape.h.

## ◆ getChildShape() [2/2]

const btConvexShape * btConvex2dShape::getChildShape | ( |  | ) | const
| inline

Definition at line 49 of file btConvex2dShape.h.

## ◆ getLocalScaling()

const btVector3 & btConvex2dShape::getLocalScaling | ( |  | ) | const
| virtual

Implements btConvexShape.

Definition at line 64 of file btConvex2dShape.cpp.

## ◆ getMargin()

btScalar btConvex2dShape::getMargin | ( |  | ) | const
| virtual

Implements btConvexShape.

Definition at line 73 of file btConvex2dShape.cpp.

## ◆ getName()

virtual const char * btConvex2dShape::getName | ( |  | ) | const
| inlinevirtual

Implements btCollisionShape.

Definition at line 54 of file btConvex2dShape.h.

## ◆ getNumPreferredPenetrationDirections()

int btConvex2dShape::getNumPreferredPenetrationDirections | ( |  | ) | const
| virtual

Implements btConvexShape.

Definition at line 78 of file btConvex2dShape.cpp.

## ◆ getPreferredPenetrationDirection()

void btConvex2dShape::getPreferredPenetrationDirection | ( | int | index,
|  | btVector3 & | penetrationVector ) const
| virtual

Implements btConvexShape.

Definition at line 83 of file btConvex2dShape.cpp.

## ◆ localGetSupportingVertex()

btVector3 btConvex2dShape::localGetSupportingVertex | ( | const btVector3 & | vec | ) | const
| virtual

Implements btConvexShape.

Definition at line 37 of file btConvex2dShape.cpp.

## ◆ localGetSupportingVertexWithoutMargin()

btVector3 btConvex2dShape::localGetSupportingVertexWithoutMargin | ( | const btVector3 & | vec | ) | const
| virtual

Implements btConvexShape.

Definition at line 27 of file btConvex2dShape.cpp.

## ◆ setLocalScaling()

void btConvex2dShape::setLocalScaling | ( | const btVector3 & | scaling | ) |
| virtual

Implements btConvexShape.

Definition at line 59 of file btConvex2dShape.cpp.

## ◆ setMargin()

void btConvex2dShape::setMargin | ( | btScalar | margin | ) |
| virtual

Implements btConvexShape.

Definition at line 69 of file btConvex2dShape.cpp.

## Member Data Documentation

## ◆ m_childConvexShape

btConvexShape* btConvex2dShape::m_childConvexShape
| private

Definition at line 27 of file btConvex2dShape.h.

The documentation for this class was generated from the following files:

- btConvex2dShape.h
- btConvex2dShape.cpp